<?php
/**
 * Created by PhpStorm.
 * User: Desenv-005
 * Date: 19/12/2018
 * Time: 17:37
 */

namespace Schaffen\WarehouseInventory\WarehouseInventory\Services;

use Schaffen\WarehouseInventory\WarehouseInventory\Models\AccountInventory;
use Schaffen\WarehouseInventory\WarehouseInventory\Repositories\SnapshotInventoryRepository;

class CreateOrUpdateSnapshotInventory
{

   /**
    * @var SnapshotInventoryRepository
    */
   private SnapshotInventoryRepository $snapshot_inventory_repository;
   /**
    * @var VerifyCanMove
    */
   private VerifyCanMove $verify_can_move;
   /**
    * @var CreateOrUpdateAccountInventory
    */
   private CreateOrUpdateAccountInventory $create_or_update_account_inventory;

   public function __construct(
      SnapshotInventoryRepository $snapshot_inventory_repository,
      VerifyCanMove $verify_can_move,
      CreateOrUpdateAccountInventory $create_or_update_account_inventory
   ){
      $this->snapshot_inventory_repository = $snapshot_inventory_repository;
      $this->verify_can_move = $verify_can_move;
      $this->create_or_update_account_inventory = $create_or_update_account_inventory;
   }

   public function storeOrUpdate($input, $recalculate_value = true)
   {

      $snapshot = $this->snapshot_inventory_repository->firstOrNew($input);
      $snapshot_update = [];

      if ($recalculate_value && $input['cc_sentido'] == AccountInventory::IN) {
            $snapshot_update['sna_valor_medio'] =
               ($snapshot->sna_quantidade * $snapshot->sna_valor_medio) +
               ($input['sna_quantidade'] * $input['cc_valor_unitario']) / ($snapshot->sna_quantidade + $input['sna_quantidade']);
      }

      $snapshot_update['sna_quantidade'] =
         round($snapshot->sna_quantidade + ($input['cc_sentido'] == AccountInventory::OUT ?
               $input['sna_quantidade'] * -1 : $input['sna_quantidade']), 4);

      return $this->snapshot_inventory_repository->storeOrUpdate($snapshot_update, $snapshot->sna_codigo);
   }


}
